/******************************************************************
*****************  				KENYA 			  *****************
*****************  		Decision making paper	  *****************
			  
*** PURPOSE: main do file 

Date: December, 2024
Stata version: 18
******************************************************************/ 												   
clear all
set more off
set dp period
set seed 1001
set varabbrev on

version 18

*** Work directory
** CHANGE THE PATH DIRECTORY HERE*****
   if "`c(username)'"=="wb558768" {
		global main   = "C:\Users\wb558768\Downloads\rep-checks\261\DntD_Replication"
	}
else if "`c(username)'"=="mquerejeta" {
		global main   = "C:\Users\mquerejeta\Dropbox\Trabajos-Concursos-etc\Oxford-WEAI\Kenya Water Survey round 2\Data and dofiles\Replication package"
	}
else if "`c(username)'"=="hille" {
		global main   = "C:\Users\hille\Dropbox\Oxford-WEAI\Kenya Water Survey round 2\Data and dofiles\Replication package"
    }
else if "`c(username)'"=="Marya Hillesland" {
		global main   = "C:\Users\Marya Hillesland\OneDrive\Desktop\Replication_package" 
	}
	
		
	* Set ado folder 
	sysdir set PLUS "${main}/ado"

	/* Not from replicators: All the dependies are stored in the ado folder and the
	packages don't need to be installed. 
	Install packages in the ado folder 
	local user_commands	palettes colrspace balancetable grc1leg2 //Add required user-written commands

	foreach command of local user_commands {
	   cap which `command'
	   if _rc == 111 {
		   ssc install `command'
	   }
	}
	*/

	* Run do files 
	do "${main}/Generating dataset.do"
	do "${main}/FINAL Tables and Figures.do"

* End of do-file!		